package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: TransactionType
// UnionValue: DirectoryAnchor

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("DirectoryAnchor")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DirectoryAnchor implements TransactionBody {
	public final TransactionType type = TransactionType.DIRECTORY_ANCHOR;
	private Url source;
	private long majorBlockIndex;
	private long minorBlockIndex;
	private long rootChainIndex;
	private byte[] rootChainAnchor;
	private byte[] stateTreeAnchor;
	private NetworkAccountUpdate[] updates;
	private PartitionAnchorReceipt[] receipts;
	private long makeMajorBlock;
	private java.time.OffsetDateTime makeMajorBlockTime;

    //
	public Url getSource() {
	    return source;
	}
	public void setSource(final Url value) {
	    this.source = value;
	}

	public DirectoryAnchor source(final Url value) {
	    setSource(value);
	    return this;
	}
	public DirectoryAnchor source(final String value) {
	    setSource(Url.toAccURL(value));
	    return this;
	}
	public long getMajorBlockIndex() {
	    return majorBlockIndex;
	}
	public void setMajorBlockIndex(final long value) {
	    this.majorBlockIndex = value;
	}

	public DirectoryAnchor majorBlockIndex(final long value) {
	    setMajorBlockIndex(value);
	    return this;
	}
	public long getMinorBlockIndex() {
	    return minorBlockIndex;
	}
	public void setMinorBlockIndex(final long value) {
	    this.minorBlockIndex = value;
	}

	public DirectoryAnchor minorBlockIndex(final long value) {
	    setMinorBlockIndex(value);
	    return this;
	}
	public long getRootChainIndex() {
	    return rootChainIndex;
	}
	public void setRootChainIndex(final long value) {
	    this.rootChainIndex = value;
	}

	public DirectoryAnchor rootChainIndex(final long value) {
	    setRootChainIndex(value);
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getRootChainAnchor() {
	    return rootChainAnchor;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setRootChainAnchor(final byte[] value) {
	    this.rootChainAnchor = value;
	}

	public DirectoryAnchor rootChainAnchor(final byte[] value) {
	    setRootChainAnchor(value);
	    return this;
	}
	public DirectoryAnchor rootChainAnchor(final String value) {
		try {
			setRootChainAnchor(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getStateTreeAnchor() {
	    return stateTreeAnchor;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setStateTreeAnchor(final byte[] value) {
	    this.stateTreeAnchor = value;
	}

	public DirectoryAnchor stateTreeAnchor(final byte[] value) {
	    setStateTreeAnchor(value);
	    return this;
	}
	public DirectoryAnchor stateTreeAnchor(final String value) {
		try {
			setStateTreeAnchor(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	public NetworkAccountUpdate[] getUpdates() {
	    return updates;
	}
	public void setUpdates(final NetworkAccountUpdate[] value) {
	    this.updates = value;
	}

	public DirectoryAnchor updates(final NetworkAccountUpdate[] value) {
	    setUpdates(value);
	    return this;
	}
	public PartitionAnchorReceipt[] getReceipts() {
	    return receipts;
	}
	public void setReceipts(final PartitionAnchorReceipt[] value) {
	    this.receipts = value;
	}

	public DirectoryAnchor receipts(final PartitionAnchorReceipt[] value) {
	    setReceipts(value);
	    return this;
	}
	public long getMakeMajorBlock() {
	    return makeMajorBlock;
	}
	public void setMakeMajorBlock(final long value) {
	    this.makeMajorBlock = value;
	}

	public DirectoryAnchor makeMajorBlock(final long value) {
	    setMakeMajorBlock(value);
	    return this;
	}
	public java.time.OffsetDateTime getMakeMajorBlockTime() {
	    return makeMajorBlockTime;
	}
	public void setMakeMajorBlockTime(final java.time.OffsetDateTime value) {
	    this.makeMajorBlockTime = value;
	}

	public DirectoryAnchor makeMajorBlockTime(final java.time.OffsetDateTime value) {
	    setMakeMajorBlockTime(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.source == null)) {
            marshaller.writeUrl(2, this.source);
        }
        if (!(this.majorBlockIndex == 0)) {
            marshaller.writeUint(3, this.majorBlockIndex);
        }
        if (!(this.minorBlockIndex == 0)) {
            marshaller.writeUint(4, this.minorBlockIndex);
        }
        if (!(this.rootChainIndex == 0)) {
            marshaller.writeUint(5, this.rootChainIndex);
        }
        if (!(this.rootChainAnchor == null || this.rootChainAnchor.length == 0)) {
            marshaller.writeHash(6, this.rootChainAnchor);
        }
        if (!(this.stateTreeAnchor == null || this.stateTreeAnchor.length == 0)) {
            marshaller.writeHash(7, this.stateTreeAnchor);
        }
        if (!(this.updates == null)) {
            marshaller.writeValue(8, updates);
        }
        if (!(this.receipts == null)) {
            marshaller.writeValue(9, receipts);
        }
        if (!(this.makeMajorBlock == 0)) {
            marshaller.writeUint(10, this.makeMajorBlock);
        }
        if (!(this.makeMajorBlockTime == null)) {
            marshaller.writeTime(11, this.makeMajorBlockTime);
        }
        return marshaller.array();
    }
}
